<template>
  <div id="activity-end-modal">
    <div class="modal">
      <div class="modal-header">
        <label>Kết thúc hoạt động</label>
      </div>
      <div class="modal-body">
        <label>Bạn có chắc chắn muốn kết thúc hoạt động:
          <br><span>{{ activity.name }}</span><br>
        </label>
      </div>
      <div class="modal-footer">
        <button class="cancel-btn" @click="closeModal">Đóng</button>
        <button v-if="!closing" class="close-btn" @click="endActivity">Kết thúc</button>
        <button v-else class="close-btn disable">Kết thúc</button>
      </div>
    </div>
  </div>
</template>

<script>
import DonationService from '@/services/DonationService'

export default {
  name: 'ActivityEndModal',
  props: {
    activity: Object
  },
  data() {
    return {
      closing: false,
      name: "",
    }
  },
  methods: {
    closeModal() {
      this.name = ""
      this.$emit('close')
    },
    async endActivity() {
      if (this.closing) return
      this.closing = true

      try {
        let response = await DonationService.closeDonation(this.activity.id, {
          dueDate: Date.now(),
          enabled: false
        })
        console.log(response)
        if (response.status == 200) {
          alert("Activity close successfully")
          this.$emit('end')
        }
        else {
          alert(response.statusText)
        }
      }
      catch (err) {
        console.log(err)
        alert('Fail to close activity')
      }
      finally {
        console.log('getCloseDonations')
        this.closing = false
      }
    }
  }
}
</script>

<style scoped>
#activity-end-modal {
  position: fixed;
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  z-index: 99;
  background-color: rgb(0, 0, 0, 0.4);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  min-width: 400px;
  background-color: #FFF;
  border-radius: 10px;
  padding: 20px;
  display: flex;
  flex-direction: column;
}

.modal>div {
  width: 100%;
  display: flex;
}

.modal-header {
  margin-bottom: 10px;
}

.modal-header>label {
  font-weight: bold;
}

.modal-body {
  margin: 10px 0px;
  flex-direction: column;
  font-size: 16px;
}

.modal-body span {
  font-weight: bold;
}

.modal-footer {
  margin-top: 10px;
  justify-content: flex-end;
}

.modal-footer button {
  margin-left: 10px;
  padding: 8px;
  border-radius: 5px;
}

.close-btn {
  border: 1px solid red;
  background-color: #f22;
  color: white;
}

.cancel-btn {
  border: 1px solid blue;
  background-color: white;
  color: blue;
}

.disable {
  border: 1px solid #f33;
  background-color: #f66;
  color: white;

}

.modal-footer button:hover {
  cursor: pointer;
}
</style>
